#include "ti-85.h"

.org $8BFF
	JP	Start
.db "PhatOs",0
	JP	rROM_CALL	; 8C09 ROM_CALL(index)
	JP	NZ,	RETPROG	; 8C0C CALL_Z(addr)
	JP	rCALL_		; 8C0F CALL_(addr)
	JP	Z,	RETPROG	; 8C12 CALL_NZ(addr)
	JP	rCALL_		; 8C15
	JP	NC,	RETPROG	; 8C18 CALL_C(addr)
	JP	rCALL_		; 8C1B
	JP	C,	RETPROG	; 8C1E CALL_NC(addr)
	JP	rCALL_		; 8C21
	JP	NZ,	RETPROG	; 8C24 JUMP_Z(addr)
	JP	rJUMP_		; 8C27 JUMP_(addr)
	JP	Z,	RETPROG	; 8C2A JUMP_NZ(addr)
	JP	rJUMP_		; 8C2D
	JP	NC,	RETPROG	; 8C30 JUMP_C(addr)
	JP	rJUMP_		; 8C33
	JP	C,	RETPROG	; 8C36 JUMP_NC(addr)
	JP	rJUMP_		; 8C39
LoadedProgAddr:
.dw 0
RomVersion:
.db $FF
VERSION:
.db "P"
ZSBYTES:
.db 0

JUMPTABLE:
.dw $FFFF	; rTX_CHARPUT
.dw $FFFF	; rD_LT_STR
.dw $FFFF	; rM_CHARPUT
.dw $FFFF	; rD_ZM_STR
.dw $FFFF	; rD_LM_STR
.dw $FFFF	; rGET_T_CUR
.dw $FFFF	; rSCROLL_UP
.dw $FFFF	; rTR_CHARPUT
.dw $FFFF	; rCLEARLCD
.dw $FFFF	; rD_HL_DECI
.dw $FFFF	; rCLEARTEXT
.dw $FFFF	; rD_ZT_STR
.dw $FFFF	; rBUSY_OFF
.dw $FFFF	; rBUSY_ON
.dw $FFFF	; tFIND_PIXEL
rROM_CALL
	LD	(HL_DATA+1),HL	; store data for later retreval
	POP	HL		; get the last byte from the stack -- should be where RET jp's to
	INC	HL		; increase it so we don't jump on our index number
	PUSH	HL		; save our new ret location
	DEC	HL		; now, go back and get that index number
	push de
	PUSH AF
	LD	A,(HL)		;load the index number
	BIT 7,A
	JR Z,INDEX80B
	SUB $72	
INDEX80B
	LD E,A
	POP AF
	SLA E			;multiply by 2
	LD	D,0
	ld HL,JUMPTABLE		;use it as an offset in our jumptable
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	ld hl,$00FF
	add hl,de
	JR LABEL3
rCALL_
	LD	(HL_DATA+1),HL
	POP	HL
	INC	HL
	INC	HL
	PUSH	HL
	DEC	HL
	DEC	HL
	JR	LABEL5
rJUMP_
	LD	(HL_DATA+1),HL
	POP	HL
LABEL5
	PUSH	DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	HL,(PROGRAM_ADDR)
	ADD	HL,DE
LABEL3:
	POP	DE
	PUSH	HL
HL_DATA
	LD	HL,08C44H
	RET
RETPROG
	EX	(SP),HL
	INC	HL
	INC	HL
	EX	(SP),HL
	RET
TitleLine:
.db "PhatOs shell test  :)", 0
ProgramTable:
.dw 0,0,0,0,0,0,0,0
BarPos:
.db 0
LastProgram:
.dw 0
TotalEntries:
.db 0
Start:
	in a, (5)
	push af			; save current selected rom page

	ld hl, (0834bh)		; save printing params
	push hl
	ld hl, (08353h)
	push hl
	ld hl, (0800ch)
	push hl
	ld hl, (08333h)
	push hl

	ld a, 7
	out (5), a		; Select page 7 for ROM version number
	ld a, (RomVersion)
	ld b, a
	ld a, (07fffh)
	cp b
	call nz, LoadNewROMMap

	ROM_CALL(BUSY_OFF)

	xor a
	ld (08353h), a

InitData:
	call ZeroMem
	ld hl, VAT_START-1-1-6-2
	ld (LastProgram), hl

	; Basics done, starting menu -------------------------

DrawMainScr:

	ROM_CALL(CLEARLCD)
	ld hl, TitleLine

	xor a
	ld (BarPos), a
	ld (CURSOR_ROW), a
	ld (CURSOR_COL), a
	inc a
	ld (CURSOR_X), a
	ld (CURSOR_Y), a

	ROM_CALL(D_ZT_STR)

	ld hl, (LastProgram)
	ld de, ProgramTable
	ld c, 8

AdvanceWord:
	ld a, 1
	ld (CURSOR_X), a
	ld a, (CURSOR_Y)
	add a, 7
	ld (CURSOR_Y), a
	jr TestWord

NextWord:
	push bc
	ld a, b
	neg
	ld c, a
	ld b, -1
	add hl, bc
	pop bc

TestWord:
;	push bc
	ld a, (VAT_END+1)
	cp h
	jr c, Bigger
	ld a, (VAT_END)
	cp l
;	pop bc
	jr nc, RanOutofProgs	; Check to see if entire memory scanned

Bigger:
	ld a, (hl)
	dec hl
	dec hl
	dec hl			; point hl to name length
	ld b, (hl)
	dec hl			; Points to name now
	cp 00ch
	jr nz, NextWord
	call IsValidProg
	jr nc, NextWord
	push hl
	push de
NextNameChar:
	ld a, (hl)
	dec hl
	push hl
	ROM_CALL(M_CHARPUT)
	pop hl
	djnz NextNameChar
	pop de
	ex (sp), hl		; save ptr to next word and
				; get start of name ptr
	
	push bc
	inc hl			; hl -> length
	inc hl			; hl -> address high
	ld b, (hl)
	inc hl			; hl -> addr low
	ld c, (hl)
	inc bc			; skip length
	inc bc
	inc bc			; skip null
	inc bc
	inc bc			; skip checksum
	ld a, c			; store low
	ld (de), a
	inc de
	ld a, b			; store high
	ld (de), a
	inc de
	ld h, b
	ld l, c
	pop bc
	ld a, 40
	ld (CURSOR_X), a
	ROM_CALL(D_ZM_STR)		; print description
	pop hl			; restore pointer to next word
	dec c
	jr nz, AdvanceWord
	ld (LastProgram), hl
	jr DoneWordScan
RanOutofProgs:
NextSpaceToNull:
;	ld hl, NoProgramMsg
;	ROM_CALL(D_ZM_STR)		; print it
	xor a
	ld (de), a
	inc de
	ld (de), a
	ld hl, VAT_START-1-1-6-2
	ld (LastProgram), hl

DoneWordScan:
	ld a, 8
	sub c
	ld (TotalEntries), a
	or a
	jp z,DrawMainScr
	; Wait for user input
	jr FirstDraw
UpdateScr:
	call DrawSelect
	ld a, (BarPos)
	add a, b
	bit 7, a			; is it negative
	jr z, NotNegative
	ld a, (TotalEntries)
	dec a
NotNegative:
	ld b, a
	ld a, (TotalEntries)
	cp b
	jr nz, SetBarPos
	ld b, 0
SetBarPos:
	ld a, b
	ld (BarPos), a
FirstDraw:
	call DrawSelect
PollKey:
	call GET_KEY
	cp 37h
	jr z, ExitShell
	cp 1
	jr nz, NotDown
	ld b, 1
	jr UpdateScr
NotDown:
	cp 4
	jr nz, NotUp
	ld b, -1
	jr UpdateScr
NotUp:
	cp 038h
	jr nz, NotMore
	jp DrawMainScr
NotMore:
	cp 009h
	jr nz, NotEnter
	call ExecuteCommand			; error here??
	jp InitData
NotEnter:
	jp PollKey
ExitShell:
	set 1, (iy+0dh)
	ROM_CALL(CLEARTEXT)
	xor a
	ld (CURSOR_ROW), a
	ld (CURSOR_COL), a
	pop hl
	ld hl, (08333h)
	pop hl
	ld hl, (0800ch)
	pop hl
	ld hl, (08353h)
	pop hl
	ld hl, (0834bh)
	pop af
	out (5), a		; restore rom page

	jp 462h			; return to normal execution??

IsValidProg:			; hl -> name of vat entry
;	ccf
;	ret			; well, like ya know...

	push hl
	push de
	inc hl			; skip name len
	inc hl			; ptr to addr
	ld d, (hl)
	inc hl
	ld e, (hl)
	ld a, (de)
	ld h, a
	inc de
	ld a, (de)
	or h
	jr z, NotValidProg
Nottoosmall:
	inc de			; skip past length
	ld a, (de)		; Check first two bytes of data
	or a
	jr nz, NotValidProg	; if first byte is not a null
___Vv:
	scf
	jr ReturnValidRes
NotValidProg:
	scf
	ccf			; set cy to zero
ReturnValidRes:
	pop de
	pop hl
	ret

DrawSelect:
	ld a, (TotalEntries)
	or a
	ret z
	push bc
	push hl

	ld a, (BarPos)
	add a, a	;*2
	add a, a	;*4
	ld h, 0
	ld l, a
	add hl, hl	;*8
	add hl, hl	;*16
	ld b, h
	ld c, l
	add hl, hl	;
	add hl, hl	;
	add hl, bc	;
	add hl, bc	;
	add hl, bc	;
	ld bc, VIDEO_MEM
	add hl, bc
	ld bc, 8*16
	add hl, bc
	ld bc, 16*7

dog:
	ld a, (hl)
	cpl
	ld (hl), a
	inc hl
	dec bc
	ld a, c
	or b
	jr nz, dog

	pop hl
	pop bc
	ret

ExecuteCommand:
	push hl
	push de
	ld a, (BarPos)
	add a, a
	ld h, 0
	ld l, a
	ld de, ProgramTable
	add hl, de
	ld de, NextOpCode
	push de
	ld e, (hl)
	inc hl
	ld d, (hl)
	ld (LoadedProgAddr), de

nextnamechar:
	ld a, (de)
	or a
	jr z, EndofName
	inc de
	jr nextnamechar

EndofName:
	inc de			; jump past last null
	push de
	call ZeroMem
	ret
NextOpCode:
	pop de
	pop hl
	ret
Waitforkey:
	call GET_KEY
	cp 37h
	ret z
	jr Waitforkey
ZeroMem:
	ld hl, 080dfh
	ld de, 080e0h
	ld bc, 000a7h
	ld (hl), 0		; Zero out first byte of text mem
	ldir
	ret

_patchmap
.db $c,6,"romfix"
LoadNewROMMap:	; a -> rom id
	ld (RomVersion), a
	ld hl, _patchmap
	rst 20h
	rst 10h			; search for it
	ex de, hl		; hl -> patchRom
	inc hl
	inc hl			; -> to patch map
	ld (LoadedProgAddr), hl
	push hl
	ret			; Execute (RET will return to previous call)
.end
